/*
 * Copyright (C) 2006 Texas Instruments, Incorporated
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#ifndef __GST_GOMX_AUDIODEC_H__
#define __GST_GOMX_AUDIODEC_H__

#include <stdbool.h>
#include <gst/gst.h>

#include <config.h>

G_BEGIN_DECLS

#define GST_GOMX_AUDIODEC(obj) (GstGOmxAudioDec *) (obj)

#if 0
#define GST_TYPE_GOMX_AUDIODEC (gst_gomx_audiodec_get_type ())
#define GST_GOMX_AUDIODEC(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GST_TYPE_GOMX_AUDIODEC, GstGOmxAudioDec))
#define GST_GOMX_AUDIODEC_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GST_TYPE_GOMX_AUDIODEC, GstGOmxAudioDecClass))
#define GST_IS_PLUGIN_TEMPLATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GST_TYPE_GOMX_AUDIODEC))
#define GST_IS_PLUGIN_TEMPLATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GST_TYPE_GOMX_AUDIODEC))

GType gst_gomx_audiodec_get_type (void);
#endif

typedef struct _GstGOmxAudioDec GstGOmxAudioDec;
typedef struct _GstGOmxAudioDecClass GstGOmxAudioDecClass;
typedef struct _GstGOmxAudioDecElementInfo GstGOmxAudioDecElementInfo;

#include "gomx.h"

struct _GstGOmxAudioDec
{
	GstElement element;

	gboolean dispose_has_run;

	GstPad *sinkpad, *srcpad;

	gboolean silent;

	GOmxCore *gomx;
	GstGOmxAudioDecElementInfo *info;

	GOmxSem *input_filled;
	GOmxSem *input_ready;
};

struct _GstGOmxAudioDecClass 
{
	GstElementClass parent_class;
	GstGOmxAudioDecElementInfo *info;
};

struct _GstGOmxAudioDecElementInfo
{
	guint id;
	gchar *name;
	gchar *omx_component;
	gchar *capitalized_name;
	gchar *longname;
	gchar *category;
};

G_END_DECLS

#endif /* __GST_GOMX_AUDIODEC_H__ */
