/*
 * Copyright (C) 2006 Texas Instruments, Incorporated
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#ifndef __GST_GOMX_AUDIOENC_H__
#define __GST_GOMX_AUDIOENC_H__

#include <stdbool.h>
#include <gst/gst.h>

#include <config.h>

G_BEGIN_DECLS

#define GST_GOMX_AUDIOENC(obj) (GstGOmxAudioEnc *) (obj)

#if 0
#define GST_TYPE_GOMX_AUDIOENC (gst_gomx_audioenc_get_type ())
#define GST_GOMX_AUDIOENC(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GST_TYPE_GOMX_AUDIOENC, GstGOmxAudioEnc))
#define GST_GOMX_AUDIOENC_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GST_TYPE_GOMX_AUDIOENC, GstGOmxAudioEncClass))
#define GST_IS_PLUGIN_TEMPLATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GST_TYPE_GOMX_AUDIOENC))
#define GST_IS_PLUGIN_TEMPLATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GST_TYPE_GOMX_AUDIOENC))

GType gst_gomx_audioenc_get_type (void);
#endif

typedef struct _GstGOmxAudioEnc GstGOmxAudioEnc;
typedef struct _GstGOmxAudioEncClass GstGOmxAudioEncClass;
typedef struct _GstGOmxAudioEncElementInfo GstGOmxAudioEncElementInfo;

#include "gomx.h"

struct _GstGOmxAudioEnc
{

	GstElement element;

	gboolean dispose_has_run;

	GstPad *sinkpad, *srcpad;

	gboolean silent;

	GOmxCore *gomx;
	GstGOmxAudioEncElementInfo *info;

	GOmxSem *input_filled;
	GOmxSem *input_ready;
};

struct _GstGOmxAudioEncClass 
{
	GstElementClass parent_class;

	GstGOmxAudioEncElementInfo *info;	
};

struct _GstGOmxAudioEncElementInfo
{
	guint id;
	gchar *name;
	gchar *omx_component;
	gchar *capitalized_name;
	gchar *longname;
	gchar *category;
};

G_END_DECLS

#endif /* __GST_GOMX_AUDIOENC_H__ */
