/*
 * Copyright (C) 2006 Texas Instruments, Incorporated
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#ifndef __GST_GOMX_SINK_H__
#define __GST_GOMX_SINK_H__

#include <gst/gst.h>

#include <gst/base/gstbasesink.h>

#include <config.h>

G_BEGIN_DECLS

#define GST_GOMX_SINK(obj) (GstGOmxSink *) (obj)

/** @todo Research for a better typing. */

#if 0
#define GST_TYPE_GOMX_SINK (gst_gomx_sink_get_type ())
#define GST_GOMX_SINK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GST_TYPE_GOMX_SINK, GstGOmxSink))
#define GST_GOMX_SINK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GST_TYPE_GOMX_SINK, GstGOmxSinkClass))
#define GST_IS_PLUGIN_TEMPLATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GST_TYPE_GOMX_SINK))
#define GST_IS_PLUGIN_TEMPLATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GST_TYPE_GOMX_SINK))

GType gst_gomx_sink_get_type (void);
#endif

typedef struct _GstGOmxSink GstGOmxSink;
typedef struct _GstGOmxSinkClass GstGOmxSinkClass;
typedef struct _GstGOmxSinkElementInfo GstGOmxSinkElementInfo;

#include "gomx.h"

struct _GstGOmxSink
{
	GstBaseSink element;

	GstPad *sinkpad;
	GstPad *srcpad;

	gboolean dispose_has_run;

	gboolean silent;

	GOmxCore *gomx;
	GstGOmxSinkElementInfo *info;

	GOmxSem *input_ready;
	GOmxSem *input_filled;
};

struct _GstGOmxSinkClass 
{
	GstBaseSinkClass parent_class;

	GstGOmxSinkElementInfo *info;
};

struct _GstGOmxSinkElementInfo
{
	guint id;
	gchar *name;
	gchar *omx_component;
	gchar *capitalized_name;
	gchar *longname;
	gchar *category;
};

G_END_DECLS

#endif /* __GST_GOMX_SINK_H__ */
